/*
 * Copyright (c) 1992 Kent State University.
 * All rights reserved.  The Kent State University 
 * software License Agreement specifies the terms and conditions 
 * for redistribution.
 *
 *	@(#)xcomm.h	1.1 (Kent State) 2/28/92
 *
 *	Author: Paul B. Ricks
 *
 *	The spirit of the Gnu Licensing Agreement Applies to this software and 
 *	Kent State University should be substituted where ever Gnu appears.
 *

#ifndef lint
static char copyright[] =
"@(#) Copyright (c) 1992 Kent State University.\n\
 All rights reserved.\n";
#endif

#ifndef lint
static char sccsid[] = "@(#)xcomm.h 1.1 (Kent State Univ.) 2/28/92";
#endif 

 *	xcomm.h contains constant definitions and structure declarations.
 *


                            NO WARRANTY

   BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

                     END OF TERMS AND CONDITIONS
*/

#include	<signal.h>
#include	<sys/uio.h>
#include	<sys/param.h>
#include	<sys/un.h>


#ifndef TRUE
#define TRUE			1
#define FALSE			0
#endif


#define LISTEN_ERROR		20
#define ACCEPT_ERROR		21
#define RECVFROM_ERROR		22
#define SENDTO_ERROR		23
#define BINDIN_SOCKET_ERROR	24
#define GETTIN_SOCKET_ERROR	25
#define SELECT_ERROR		26
#define SEND_FILE_ERROR		27
#define CONNECT_ERROR		28

#define	NEW_MESSAGE		40
#define	LEFT_REQUEST		41
#define RINGING_AGAIN		42
#define	MADE_CONTACT		43
#define WAITING_FOR_RESPOND	44
#define	HANGED_UP		45
#define	RESTART			46
#define	URGENT_RESTART		47
#define TRY_LATER		48
#define ON_HOLD			49
#define WILL_HOLD		50
#define	RE_INVITE		51
#define	CANCELED		52
#define	TALK_LINE		53
#define	TRYING_REMOTE		54
#define	TRYING_LOCAL		55
#define	HASNT_CONNECTED		56
#define	NUT_HOUSE		99

#define DONT_QUECALLS		0
#define DO_QUECALLS		1

#define HIS_INFORMATION		60
#define LOST_CONNECTION		61
#define DAEMON_RESPONSE		62
#define TASK_ABORTED		63
#define	PUT_ONHOLD		64

#define MAKE_CALL		1
#define ACCEPT_CALL		2
#define REFUSE_CALL		3
#define ABORT_CALL		4
#define TAKE_MSG		5
#define HANG_UP			7
#define AUTO_ANSWER		8

#define MAX_TRIES		4
#define	MAX_QUE_CALLS		5
#define	MAX_OLD_CALLS		10
#define	MAX_MSGBUF		80
#define	MAX_LINES		10
#define	MAX_ELAPSE_MSG_TIME	20
#define MAX_FOREIGN_SITES	15
#define MAX_DAEMONS		5

#define EDCHARS_LEN		3
#define	ADDRESS_LEN		15	
#define QUIT_CODE		22
#define MACHINE_NAMELEN		64
#define HISBUFFER_LEN		1024
#define MYBUFFER_LEN		1024
#define MESSAGE_LENGTH		1024
#define	BIG_NAME_SIZE		NAME_SIZE 

#define LOCAL_ADDRESS_FILE	"~ricks/xcomm/addresses"

typedef struct local_msg {		/* structure for communication between child & parent */
	char	line[MAX_MSGBUF];	/* passing buffer */
	char	id;			/* request id */
	char	type;			/* request type */
} LOCAL_MSG;

typedef struct que_call {
	char  id;			/* id given to the call by child process */
	CTL_MSG  call;			/* contain call information */
	struct timeval arrivaltime;	/* used to determine fresh calls from old ones */
} QUE_CALL;

typedef struct {			/* answering machine data structure */
	u_char status;
	struct timeval time;		/* time stamp message */
	char u_name[BIG_NAME_SIZE];	/* user name */
	char line[MESSAGE_LENGTH];	/* message text */
	struct in_addr address;		/* address of message */
} MESSAGE_REC;

typedef struct {			/* structure for eliminating old calls */
	int port;			/* port of call */
	char u_name[NAME_SIZE];		/* user name of caller */
	struct in_addr address;		/* address of call */
} OLD_CALLS;
